package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CourseStreamingBusinessAddBo;
import com.zhongzheng.modules.course.bo.CourseStreamingBusinessEditBo;
import com.zhongzheng.modules.course.bo.CourseStreamingBusinessQueryBo;
import com.zhongzheng.modules.course.domain.CourseStreamingBusiness;
import com.zhongzheng.modules.course.mapper.CourseSectionBusinessMapper;
import com.zhongzheng.modules.course.mapper.CourseStreamingBusinessMapper;
import com.zhongzheng.modules.course.service.ICourseStreamingBusinessService;
import com.zhongzheng.modules.course.vo.CourseStreamingBusinessVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 课程流适用业务关系Service业务层处理
 *
 * @author hjl
 * @date 2021-10-11
 */
@Service
public class CourseStreamingBusinessServiceImpl extends ServiceImpl<CourseStreamingBusinessMapper, CourseStreamingBusiness> implements ICourseStreamingBusinessService {

    @Autowired
    private CourseStreamingBusinessMapper courseStreamingBusinessMapper;

    @Override
    public CourseStreamingBusinessVo queryById(Long id){
        CourseStreamingBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, CourseStreamingBusinessVo.class);
    }

    @Override
    public List<CourseStreamingBusiness> getListById(Long id) {
        return courseStreamingBusinessMapper.getListById(id);
    }

    @Override
    public List<CourseStreamingBusinessVo> queryList(CourseStreamingBusinessQueryBo bo) {
        LambdaQueryWrapper<CourseStreamingBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getStreamingId() != null, CourseStreamingBusiness::getStreamingId, bo.getStreamingId());
        lqw.eq(bo.getEducationTypeId() != null, CourseStreamingBusiness::getEducationTypeId, bo.getEducationTypeId());
        lqw.eq(bo.getBusinessId() != null, CourseStreamingBusiness::getBusinessId, bo.getBusinessId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseStreamingBusinessVo> entity2Vo(Collection<CourseStreamingBusiness> collection) {
        List<CourseStreamingBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseStreamingBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseStreamingBusiness> page = (Page<CourseStreamingBusiness>)collection;
            Page<CourseStreamingBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseStreamingBusinessAddBo bo) {
        CourseStreamingBusiness add = BeanUtil.toBean(bo, CourseStreamingBusiness.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseStreamingBusinessEditBo bo) {
        CourseStreamingBusiness update = BeanUtil.toBean(bo, CourseStreamingBusiness.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseStreamingBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
